songs/forms.py
from flask_wtf import FlaskForm
from flask_wtf.file import FileField, FileAllowed
from wtforms import StringField, SubmitField
from wtforms.validators import DataRequired


class UploadForm(FlaskForm):
    title = StringField('Title', validators=[DataRequired()])
    song_image = FileField('Upload Song Picture', validators=[
                           FileAllowed(['jpg', 'png'])])
    song_file = FileField('Upload song', validators=[
        DataRequired(), FileAllowed(['mp3', 'ogg', 'wav'])])
    submit = SubmitField('Upload')


class UpdateSongForm(FlaskForm):
    title = StringField('Title',
                        validators=[DataRequired()])
    picture = FileField('Update Song Picture', validators=[
                        FileAllowed(['jpg', 'png'])])
    submit = SubmitField('Update')

main/routes.py
from flask import Blueprint
from flask import render_template, request, flash
from flask_login import login_required
from soundcloud.users.utils import post_comments
from soundcloud.services import get_song_list, get_count_list

main = Blueprint("main", __name__)


@main.route("/")
@main.route("/home", methods=["GET", "POST"])
def home():
    page = request.args.get("page", 1, type=int)
    songs = get_song_list(page)
    play = get_count_list()
    print(play)
    return render_template("home.html", songs=songs, play=play)


@main.route("/about")
def about():
    return render_template("about.html", title="About")


@main.route("/home/post_comment", methods=["GET", "POST"])
@login_required
def post_comment():
    res = request.get_json()
    print(res)
    if len(res) == 3:
        post_comments(res)
        flash("Your comment has been posted.", "success")
    return render_template("songs.html", song_id=res["song_id"])


# @main.route("/search", methods=["GET", "POST"])
# def search():
#     if request.method == "POST":
#         keyword = request.form["search"]
#         body = {"query": {"multi_match": {"query": keyword}}}
#     else:
#         keyword = request.args.get("q", None)
#         body = {"query": {"multi_match": {"query": keyword}}}
#         print(keyword)

#     res = es.search(index="soundcloud", doc_type="songs", body=body)

#     if res["hits"]["hits"]:
#         res = res["hits"]["hits"]
#         print(res)
#         return render_template("search.html", title="Search Results", res=res)
#     else:
#         res = "Not Found"
#         return render_template("search.html", title="Search Results", res=res)

songs/routes.py
from flask import Blueprint
from flask import render_template, url_for, flash, redirect, request
from soundcloud import db
from flask_login import login_required, current_user
from soundcloud.songs.forms import UploadForm, UpdateSongForm
from soundcloud.users.utils import upload_songs, save_media
from soundcloud.songs.model import PlayCount
from soundcloud.services import get_all_comments, get_song, get_path, get_count

songs = Blueprint("songs", __name__)




@songs.route("/upload", methods=["GET","POST"])
@login_required
def upload_song():
    form = UploadForm()
    if request.method == "POST":
        if form.validate_on_submit():
            song_file = request.files["song_file"]
            print(form.title.data)
            song = upload_songs(form.title.data, form.song_image.data, song_file)
            # create_object(form.title.data, song.id)
            flash("Your song has been uploaded!", "success")
            return redirect(url_for("songs.song", song_id=song.id))
    return render_template(
        "upload_song.html", title = "New Song", form = form, legend = "New Song"
    )

@songs.route("/song/<int:song_id>", methods = ["GET"])
def song(song_id):
    comments=get_all_comments(song_id)
    song=get_song(song_id)
    filepath=get_path(song.filepath)
    image_file=get_path(song.image_file)
    count=get_count(song_id)
    return render_template(
        "songs.html",
        title = "Song details",
        count = count,
        song = song,
        comments = comments,
        song_id = song_id,
        image_file = image_file,
        filepath = filepath,
    )


@songs.route("/songs/play_count", methods = ["POST"])
@login_required
def play_count():
    res=request.get_json()
    if len(res) == 1:
        check=PlayCount.query.filter_by(
            song_id = res["song_id"], user_name = current_user.id).first()
        if check is None:
            playCount=PlayCount(user_name = current_user.id,
                                song_id = res["song_id"])
            db.session.add(playCount)
            db.session.commit()
    return redirect(request.referrer)


@songs.route("/update-song/<song_id>", methods = ["GET", "POST"])
@login_required
def update_song(song_id):
    form=UpdateSongForm()
    song=get_song(song_id)
    filepath=get_path(song.filepath)
    image_file=get_path(song.image_file)
    if song.user_id == current_user.id:
        if form.validate_on_submit():
            if form.picture.data:
                picture_file="static/img/" + save_media(
                    form.picture.data, "static/img"
                )
                song.image_file = picture_file
            song.title = form.title.data
            db.session.commit()

           # update_object(form.title.data, song_id)
            flash("Your song has been updated!", "success")
            return redirect(url_for("songs.song", song_id=song_id))
        elif request.method == "GET":
            form.title.data = song.title
        return render_template(
            "update-song.html",
            title="Edit Song",
            image_file=image_file,
            song=song,
            form=form,
        )
    else:
        return render_template("500.html")

users/routes.py
from flask import Blueprint
from flask import render_template, url_for, flash, redirect, request
from soundcloud import db, bcrypt
from soundcloud.users.forms import RegistrationForm, LoginForm, UpdateAccountForm
from soundcloud.users.utils import save_media
from soundcloud.users.model import User
from soundcloud.songs.model import Songs
from soundcloud.services import get_all_songs_by_user
from flask_login import login_user, current_user, logout_user, login_required


users = Blueprint("users", __name__)


@users.route("/register", methods=["GET", "POST"])
def register():
    if current_user.is_authenticated:
        return redirect(url_for("main.home"))
    form = RegistrationForm()
    if form.validate_on_submit():
        hashed_password = bcrypt.generate_password_hash(form.password.data).decode(
            "utf-8"
        )
        user = User(
            username=form.username.data, email=form.email.data, password=hashed_password
        )
        db.session.add(user)
        db.session.commit()
        flash("Your account has been created! You are now able to log in", "success")
        return redirect(url_for("users.login"))
    return render_template("register.html", title="Register", form=form)


@users.route("/login", methods=["GET", "POST"])
def login():
    if current_user.is_authenticated:
        return redirect(url_for("main.home"))
    form = LoginForm()
    if form.validate_on_submit():
        user = User.query.filter_by(email=form.email.data).first()
        if user and bcrypt.check_password_hash(user.password, form.password.data):
            login_user(user, remember=form.remember.data)
            next_page = request.args.get("next")
            return redirect(next_page) if next_page else redirect(url_for("main.home"))
        else:
            flash("Login Unsuccessful. Please check email and password", "danger")
    return render_template("login.html", title="Login", form=form)


@users.route("/logout")
def logout():
    logout_user()
    return redirect(url_for("main.home"))


@users.route("/update-account", methods=["GET", "POST"])
@login_required
def update_account():
    form = UpdateAccountForm()
    if form.validate_on_submit():
        if form.picture.data:
            picture_file = save_media(form.picture.data, "static/profile_pics")
            current_user.image_file = picture_file
        current_user.username = form.username.data
        current_user.email = form.email.data
        db.session.commit()
        flash("Your account has been updated!", "success")
        return redirect(url_for("users.account"))
    elif request.method == "GET":
        form.username.data = current_user.username
        form.email.data = current_user.email
        image_file = url_for(
            "static", filename="profile_pics/" + current_user.image_file
        )

    return render_template(
        "update-account.html", title="Account", image_file=image_file, form=form
    )


@users.route("/account")
@login_required
def account():
    songs = get_all_songs_by_user(current_user.id)
    image_file = url_for("static", filename="profile_pics/" + current_user.image_file)

    return render_template("account.html", songList=songs, image_file=image_file)


@users.route("/like/<int:song_id>/<action>")
@login_required
def like_action(song_id, action):
    song = Songs.query.filter_by(id=song_id).first_or_404()
    if action == "like":
        current_user.like(song)
        db.session.commit()
    if action == "unlike":
        current_user.unlike(song)
        db.session.commit()

    return redirect(request.referrer)

templates/about.html
 {% extends "layout.html" %} {% block content %}

<div class="">
    <h1>About SoundCloud</h1>
    <p>This is a music streaming website created in Python-Flask. Lorem, ipsum dolor sit amet consectetur adipisicing elit. Reprehenderit ex quasi suscipit. Nihil, incidunt illum accusantium maiores est iste. Consequuntur reiciendis quaerat qui aliquid blanditiis
        officia commodi beatae. Harum, pariatur.
    </p>

</div>
{% endblock content %}

templates/account.html
{% extends "layout.html" %} {% block content %}
<div class="content-section">
    <div class="media">
        <img class="rounded-circle account-img" src="{{ image_file }}">
        <div class="media-body">
            <input id="user_id" type="hidden" value={{current_user.id}}>
            <h2 id="username" class="account-heading">{{ current_user.username }}</h2>
            <p id="email" class="text-secondary">{{ current_user.email }}</p>

            <div>
                <a href="{{url_for('users.update_account')}}">Edit your Profile</a>
                <button class="btn btn-outline-info" id="bg-download" onclick="startTask()">Download your Info</button>
            </div>
            <br>
            <div id="progress"></div>

            <div class="inner-media-body"></div>
        </div>
    </div>
</div>

<div class="content-section">
    <h2 class="upload-head">Songs Uploaded by You</h2>
    <br>
    <ul>
        {% for song in songList %}
        <li class="list-group-item">
            <a class="song_title" href="{{url_for('songs.song',song_id=song.id)}}">{{song.title}}
                 <a class="btn btn-sm float-right delete" href="{{url_for('songs.update_song',song_id=song.id)}}">Edit Song Details</a>
            </a>
        </li>
        {%endfor%}
    </ul>


    <!-- <button class="btn btn-sm float-right delete">Edit Song Details</button> -->
</div>

{% endblock content %}

templates/home.html
 {% extends "layout.html" %} {% block content %} {% for song in songs.items %}
<br>
<div class="media">
    <img class="d-flex mr-3" src={{song.image_file}}>
    <div class="media-body">
        <input type="hidden" id="song_id" value={{song.id}}>
        <a href="{{url_for('songs.song',song_id=song.id)}}">
            <h4> {{song.title}}</h4>
        </a>
        {%for s in play%} {%if s[0] == song.id %}
        <small>PlayCount :{{s[1]}} </small> {%endif%} {%endfor%}

        <br> {% if current_user.is_authenticated %}
        <audio controls class="audio-player" onplaying="countfn({{song.id}})">
      <source src={{song.filepath}} type="audio/mpeg" loop="false" autostart="false" hidden="true" >
         </audio> {%else%}
        <audio controls class="audio-player">
            <source src={{song.filepath}} type="audio/mpeg" loop="false" autostart="false" hidden="true" >
               </audio> {%endif%} {% if current_user.is_authenticated %}

        <button class="comment-btn">Comment</button>
        <div id="comment-body" class="media-body"></div>{% endif %}
        <a href="{{url_for('songs.song',song_id=song.id)}} ">view comments</a>

        <div class="media-body">{% if current_user.is_authenticated %}{% if current_user.is_liking(song) %}
            <a href="{{ url_for('users.like_action', song_id=song.id, action='unlike') }}">Unlike</a> {% else %}
            <a href="{{ url_for('users.like_action', song_id=song.id, action='like') }}">Like</a> {% endif %}{{ song.likes.count() }} likes {% else%} {{ song.likes.count() }} likes {%endif%}
        </div>

    </div>
</div> {% endfor %}
<br> {% for page_num in songs.iter_pages(left_edge=1, right_edge=1, left_current=1, right_current=2) %} {% if page_num %} {% if songs.page == page_num %}
<a class="btn btn-info mb-4" href="{{ url_for('main.home', page=page_num) }}">{{ page_num }}</a> {% else %}
<a class="btn btn-outline-info mb-4" href="{{ url_for('main.home', page=page_num) }}">{{ page_num }}</a> {% endif %} {% else %} ... {% endif %} {% endfor %} {% endblock content %}

templates/layout.html
<!DOCTYPE html>
<html>

<head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <link href='https://fonts.googleapis.com/css?family=Lora:400,700,400italic,700italic' rel='stylesheet' type='text/css'>
    <link href='https://fonts.googleapis.com/css?family=Open+Sans:300italic,400italic,600italic,700italic,800italic,400,300,600,700,800' rel='stylesheet' type='text/css'>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link href="/static/css/clean-blog.min.css" rel="stylesheet">
    <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='css/main.css') }}">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
    <link rel="stylesheet" type="text/css" href="{{ url_for('static', filename='css/main.css') }}"> {% if title %}
    <title>SoundCloud - {{ title }}</title>
    {% else %}
    <title>SoundCloud</title>
    {% endif %}
</head>

<body>
    <nav class="navbar navbar-expand-md navbar-dark bg-steel fixed-top">
        <div class="container">
            <a class="navbar-brand" href="/">SoundCloud</a>
            <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle" aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
            <div class="collapse navbar-collapse" id="navbarResponsive">
                <div class="navbar-nav mr-auto">
                    <a class="nav-item nav-link" href="{{ url_for('main.home') }}">Home</a>
                    <a class="nav-item nav-link" href="{{ url_for('main.about') }}">About</a>
                </div>
                <div class="navbar-nav mr-auto">
                    <form method="POST" action="{{url_for('main.search')}}">
                        <input type="text" placeholder="Search.." name="search">
                        <button type="submit"><i class="fa fa-search"></i></button>
                    </form>
                </div>
                <!-- Navbar Right Side -->
                <div class="navbar-nav">
                    {% if current_user.is_authenticated %}
                    <a class="nav-item nav-link" href="{{ url_for('songs.upload_song') }}">Upload</a>
                    <a class="nav-item nav-link" href="{{ url_for('users.account') }}">Account</a>
                    <a class="nav-item nav-link" href="{{ url_for('users.logout') }}">Logout</a> {% else %}
                    <a class="nav-item nav-link" href="{{ url_for('users.login') }}">Login</a>
                    <a class="nav-item nav-link" href="{{ url_for('users.register') }}">Register</a> {% endif %}
                </div>
            </div>
        </div>
    </nav>

    <!-- </header> -->

    <main role="main" class="container">
        <div class="row">
            <div class="col-md-8">
                {% with messages = get_flashed_messages(with_categories=true) %} {% if messages %} {% for category, message in messages %}
                <div class="alert alert-{{ category }}">
                    {{ message }}
                </div>
                {% endfor %} {% endif %} {% endwith %} {% block content %}{% endblock %}
            </div>
        </div>
    </main>


    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
    <script src="/static/js/main.js"></script>
    <script src="/static/js/comment.js"></script>
    <script src="/static/js/playCount.js"></script>
    <script src="/static/js/background.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/nanobar/0.2.1/nanobar.min.js"></script>
    <script src="//cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
</body>

</html>

templates/login.html
 {% extends "layout.html" %} {% block content %}
<div class="content-section">
    <form method="POST" action="">
        {{ form.hidden_tag() }}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Log In</legend>
            <div class="form-group">
                {{ form.email.label(class="form-control-label") }} {% if form.email.errors %} {{ form.email(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.email.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.email(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-group">
                {{ form.password.label(class="form-control-label") }} {% if form.password.errors %} {{ form.password(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.password.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.password(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-check">
                {{ form.remember(class="form-check-input") }} {{ form.remember.label(class="form-check-label") }}
            </div>
        </fieldset>
        <div class="form-group">
            {{ form.submit(class="btn btn-outline-info") }}
        </div>
    </form>
</div>
<div class="border-top pt-3">
    <small class="text-muted">
            Need An Account? <a class="ml-2" href="{{ url_for('users.register') }}">Sign Up Now</a>
        </small>
</div>
{% endblock content %}

templates/register.html
{% extends "layout.html" %} {% block content %}
<div class="content-section">
    <form method="POST" action="">
        {{ form.hidden_tag() }}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Sign Up</legend>
            <div class="form-group">
                {{ form.username.label(class="form-control-label") }} {% if form.username.errors %} {{ form.username(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.username.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.username(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-group">
                {{ form.email.label(class="form-control-label") }} {% if form.email.errors %} {{ form.email(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.email.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.email(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-group">
                {{ form.password.label(class="form-control-label") }} {% if form.password.errors %} {{ form.password(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.password.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.password(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-group">
                {{ form.confirm_password.label(class="form-control-label") }} {% if form.confirm_password.errors %} {{ form.confirm_password(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.confirm_password.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.confirm_password(class="form-control form-control-lg") }} {% endif %}
            </div>
        </fieldset>
        <div class="form-group">
            {{ form.submit(class="btn btn-outline-info") }}
        </div>
    </form>
</div>
<div class="border-top pt-3">
    <small class="text-muted">
            Already Have An Account? <a class="ml-2" href="{{ url_for('users.login') }}">Sign In</a>
        </small>
</div>
{% endblock content %}

templates/search.html
{% extends "layout.html" %} {% block content %}

<h1>Search Results</h1>
<div class="container">
    {%if res=="Not Found" %}
    <h2>File Not found</h2>
    {%else%} {%for song in res%}
    <ul>
        <li>
            <a href="{{url_for('songs.song',song_id=song['_source']['Song_id'])}}">

                {{ song['_source']['title'] }}
            </a>
        </li>

    </ul>
    {%endfor%} {%endif%}
</div>
{% endblock %}

templates/songs.html
{% extends "layout.html" %} {% block content %}
<div class="media">
    <img class="d-flex mr-3" src="{{url_for('static',filename=image_file)}}">
    <div class="media-body">
        <input type="hidden" id="song_id" value={{song_id}}>
        <h4> {{song.title}}</h4>
        <small>PlayCount : {{count}}</small>
        <br> {% if current_user.is_authenticated %}
        <audio controls class="audio-player" onplaying="countfn({{ song.id }})">
      <source src="{{url_for('static',filename=filepath)}}" type="audio/mpeg" loop="false" autostart="false" hidden="true" >
         </audio> {%else%}
        <audio controls class="audio-player">
            <source src="{{url_for('static',filename=filepath)}}" type="audio/mpeg" loop="false" autostart="false" hidden="true" >
               </audio> {%endif%} {% if current_user.is_authenticated %}
        <button class="comment-btn">Comment</button> {% endif %}
        <div id="comment-body" class="media-body"></div>

        <div class="media-body">{% if current_user.is_authenticated %}{% if current_user.is_liking(song) %}
            <a href="{{ url_for('users.like_action', song_id=song.id, action='unlike') }}">Unlike</a> {% else %}
            <a href="{{ url_for('users.like_action', song_id=song.id, action='like') }}">Like</a> {% endif %}{{ song.likes.count() }} likes {% else%} {{ song.likes.count() }} likes {%endif%}
        </div> <br><br id="line-break">
        <div>{%for comment in comments%}
            <div class="media-body">

                <h2>{{comment.user_name}}</h2>

                <p>{{comment.comment}}</p>
                <small>timestamp :<a class="link"> {{comment.timestamp}} </a> </small></div><br> {%endfor%}

        </div>
    </div>
    {% endblock content %}

templates/update-account.html
{% extends "layout.html" %} {% block content %}
<div class="content-section">
    <div class="media">
        <img class="rounded-circle account-img" src="{{ image_file }}">
        <div class="media-body">
            <h2 id="username" class="account-heading">{{ current_user.username }}</h2>
            <p class="text-secondary">{{ current_user.email }}</p>
        </div>
    </div>
    <form method="POST" action="" enctype="multipart/form-data">
        {{ form.hidden_tag() }}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Account Info</legend>
            <div class="form-group">
                {{ form.username.label(class="form-control-label") }} {% if form.username.errors %} {{ form.username(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.username.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.username(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-group">
                {{ form.email.label(class="form-control-label") }} {% if form.email.errors %} {{ form.email(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.email.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.email(class="form-control form-control-lg") }} {% endif %}
            </div>
            <div class="form-group">
                {{ form.picture.label() }} {{ form.picture(class="form-control-file") }} {% if form.picture.errors %} {% for error in form.picture.errors %}
                <span class="text-danger">{{ error }}</span></br>
                {% endfor %} {% endif %}
            </div>
        </fieldset>
        <div class="form-group">
            {{ form.submit(class="btn btn-outline-info") }}
        </div>
    </form>

</div>
{% endblock content %}

templates/update-song.html
{% extends "layout.html" %} {% block content %}
<div class="content-section">
    <div class="media">
        <img class="d-flex mr-3" src="{{url_for('static',filename=image_file)}}">
        <div class="media-body">
            <h2 id="song-title" class="account-heading">{{ song.title }}</h2>
        </div>
    </div>
    <form method="POST" action="" enctype="multipart/form-data">
        {{ form.hidden_tag() }}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">Song Details</legend>
            <div class="form-group">
                {{ form.title.label(class="form-control-label") }} {% if form.title.errors %} {{ form.title(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.title.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.title(class="form-control form-control-lg") }} {% endif %}
            </div>

            <div class="form-group">
                {{ form.picture.label() }} {{ form.picture(class="form-control-file") }} {% if form.picture.errors %} {% for error in form.picture.errors %}
                <span class="text-danger">{{ error }}</span></br>
                {% endfor %} {% endif %}
            </div>
        </fieldset>
        <div class="form-group">
            {{ form.submit(class="btn btn-outline-info") }}
        </div>
    </form>

</div>
{% endblock content %}

templates/upload_song.html
{% extends "layout.html" %} {% block content %}
<div class="content-section">
    <form method="POST" enctype="multipart/form-data">
        {{ form.hidden_tag() }}
        <fieldset class="form-group">
            <legend class="border-bottom mb-4">{{ legend }}</legend>
            <div class="form-group">
                {{ form.title.label(class="form-control-label") }} {% if form.title.errors %} {{ form.title(class="form-control form-control-lg is-invalid") }}
                <div class="invalid-feedback">
                    {% for error in form.title.errors %}
                    <span>{{ error }}</span> {% endfor %}
                </div>
                {% else %} {{ form.title(class="form-control form-control-lg") }} {% endif %}
                <div class="form-group">
                    {{ form.song_image.label() }} {{ form.song_image(class="form-control-file") }} {% if form.song_image.errors %} {% for error in form.song_image.errors %}
                    <span class="text-danger">{{ error }}</span></br>
                    {% endfor %} {% endif %}
                </div>
                <div class="form-group">
                    {{ form.song_file.label() }} {{ form.song_file(class="form-control-file") }} {% if form.song_file.errors %} {% for error in form.song_file.errors %}
                    <span class="text-danger">{{ error }}</span></br>
                    {% endfor %} {% endif %}
                </div>
            </div>

        </fieldset>
        <div class="form-group">
            {{ form.submit(class="btn btn-outline-info") }}
        </div>
    </form>
</div>
{% endblock content %}